'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _addstyle = require('./addstyle');

var _addstyle2 = _interopRequireDefault(_addstyle);

var _keyframe = require('./keyframe');

var _keyframe2 = _interopRequireDefault(_keyframe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _addstyle2.default)(_keyframe2.default);

exports.default = {
  hide: {
    opacity: 0,
    transition: 'opacity 0.2s',
    webkitTransition: 'opacity 0.2s'
  },

  imageview: {
    position: 'fixed',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0,
    width: '100%',
    height: '100%',
    zIndex: '900',
    backgroundColor: '#000000',
    overflow: 'hidden',
    animation: 'easeshow 0.25s'
  },

  imageviewPage: {
    position: 'fixed',
    fontSize: '14px',
    color: '#ffffff',
    padding: '2px 5px',
    bottom: '10px',
    left: '50%',
    webkitTransform: 'translateX(-50%)',
    transform: 'translateX(-50%)',
    webkitTouchCallout: 'none',
    webkitUserSelect: 'none'
  },

  imageviewSpinner: {
    width: '40px',
    height: '40px',
    position: 'absolute',
    top: '45%',
    left: '50%',
    transform: 'translate(-50%, -50%)'
  },

  doubleBounce1: {
    width: '100%',
    height: '100%',
    borderRadius: '50%',
    backgroundColor: '#333',
    opacity: '0.6',
    position: 'absolute',
    top: '0',
    left: '0',

    webkitAanimation: 'sk-bounce 2s infinite ease-in-out',
    animation: 'sk-bounce 2s infinite ease-in-out'
  },
  doubleBounce2: {
    width: '100%',
    height: '100%',
    borderRadius: '50%',
    backgroundColor: '#333',
    opacity: '0.6',
    position: 'absolute',
    top: '0',
    left: '0',
    webkitAanimation: 'sk-bounce 2s infinite ease-in-out',
    animation: 'sk-bounce 2s infinite ease-in-out',
    webkitAanimationDelay: '-1s',
    animationDelay: '-1s'
  },

  errorpage: {
    position: 'absolute',
    fontSize: '16px',
    textAlign: 'center',
    color: 'rgb(170, 170, 170)',
    top: '28%',
    left: '50%',
    marginLeft: '-70px'
  },

  errorpageBefore: {
    content: '',
    display: 'block',
    width: '150px',
    height: '140px',
    margin: '0 auto',
    paddingBottom: '20px',
    // background: 'url('./net-error.png') no-repeat',
    backgroundSize: '100%',
    opacity: 0.4
  },

  imagelist: {
    height: '100%',
    flexDirection: 'row'
  },
  'imagelist-item': {
    width: '100%',
    height: '100%',

    position: 'relative',
    backgroundColor: '#000000',
    overflowY: 'scroll'
  },
  img: {
    position: 'absolute',
    top: 0,
    left: 0,
    maxWidth: '100%'
  }
};
module.exports = exports['default'];