'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CenterImage = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeImage = require('nuke-image');

var _nukeImage2 = _interopRequireDefault(_nukeImage);

var _index = require('../styles/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** @jsx createElement */


var PRELOADNUM = 3;

var CenterImage = exports.CenterImage = function (_Component) {
  _inherits(CenterImage, _Component);

  function CenterImage() {
    _classCallCheck(this, CenterImage);

    var _this = _possibleConstructorReturn(this, (CenterImage.__proto__ || Object.getPrototypeOf(CenterImage)).call(this));

    _this.state = {
      error: false,
      loaded: false
    };
    _this.dom = null;
    return _this;
  }

  _createClass(CenterImage, [{
    key: 'findDom',
    value: function findDom() {
      if (!this.dom) {
        this.dom = (0, _rax.findDOMNode)(this.refs.img);
      }
      return this.dom;
    }
  }, {
    key: 'render',
    value: function render() {
      var error = this.state.error,
          _props = this.props,
          index = _props.index,
          current = _props.current,
          lazysrc = _props.lazysrc,
          onLoad = _props.onLoad,
          childProps = _objectWithoutProperties(_props, ['index', 'current', 'lazysrc', 'onLoad']),
          img = (0, _rax.createElement)(_nukeImage2.default, _extends({
        ref: 'img',
        onLoad: this.onImgLoad.bind(this),
        src: lazysrc
      }, childProps));

      // init first image, others have been preloaded
      if (index === current) {
        return img;
      }

      if (error) {
        return (0, _rax.createElement)(Error, null);
      }

      return img;
    }
  }, {
    key: 'setStyle',
    value: function setStyle(styleData) {
      var elementStyle = this.findDom().style;
      for (var styleName in styleData) {
        elementStyle[styleName] = styleData[styleName];
      }
    }
  }, {
    key: 'onImgLoad',
    value: function onImgLoad(e) {

      this.setState({ loaded: true });

      var target = e.target,
          h = target.naturalHeight,
          w = target.naturalWidth,
          r = h / w,
          height = window.innerHeight || window.screen.availHeight,
          width = window.innerWidth || window.screen.availWidth,
          rate = height / width;

      var imgStyle = {};

      if (r >= 3.5) {
        // imgStyle.width = width + "px";
        // imgStyle.height = h * width / w + "px";
        target.setAttribute('long', true);
      }

      if (r > rate) {
        imgStyle.height = height + 'px';
        imgStyle.width = w * height / h + 'px';
        imgStyle.left = width / 2 - w * height / h / 2 + 'px';
      } else if (r < rate) {
        imgStyle.width = width + 'px';
        imgStyle.height = h * width / w + 'px';
        imgStyle.top = height / 2 - h * width / w / 2 + 'px';
      } else {
        imgStyle.width = width;
        imgStyle.height = height;
      }
      this.setStyle(imgStyle);

      target.setAttribute('rate', 1 / r);
      this.props.onLoad && this.props.onLoad(e, this.props.index);
    }
  }]);

  return CenterImage;
}(_rax.Component);

var Loading = function Loading() {
  return (0, _rax.createElement)(
    _nukeView2.default,
    { className: 'spinner', style: _index2.default.spinner },
    (0, _rax.createElement)(_nukeView2.default, { className: 'double-bounce1', style: _index2.default.doubleBounce1 }),
    (0, _rax.createElement)(_nukeView2.default, { className: 'double-bounce2', style: _index2.default.doubleBounce2 })
  );
};

var Error = function Error() {
  return (0, _rax.createElement)(
    _nukeView2.default,
    { className: 'errorpage', style: _index2.default.errorpage },
    '\u52A0\u8F7D\u5931\u8D25'
  );
};