'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _finger = require('./finger');

var _finger2 = _interopRequireDefault(_finger);

var _transform = require('./transform.js');

var _transform2 = _interopRequireDefault(_transform);

var _components = require('./components.js');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _index = require('../styles/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** @jsx createElement */


var MARGIN = 30;

var ImageView = function (_Component) {
  _inherits(ImageView, _Component);

  function ImageView(props) {
    _classCallCheck(this, ImageView);

    var _this = _possibleConstructorReturn(this, (ImageView.__proto__ || Object.getPrototypeOf(ImageView)).call(this));

    _this.arrLength = props.imageList.length;
    _this.state = {
      current: props.current
    };
    _this.onOrientationChange = _this.onOrientationChange.bind(_this);
    _this.initScale = 1;
    _this.screenWidth = window.innerWidth || window.screen.availWidth;
    _this.screenHeight = window.innerHeight || window.screen.availHeight;
    _this.list = null;
    _this.ob = null;
    _this.focused = null;
    return _this;
  }

  _createClass(ImageView, [{
    key: 'onOrientationChange',
    value: function onOrientationChange() {
      // // 方向改变后新的innerHeight生效需要delay
      // setTimeout(() => {
      //   this.screenWidth = window.innerWidth || window.screen.availWidth;
      //   this.screenHeight = window.innerHeight || window.screen.availHeight;
      //   this.changeIndex(this.state.current);
      // }, 100);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          desc = _props.desc,
          disablePageNum = _props.disablePageNum,
          imageList = _props.imageList,
          children = _props.children,
          gap = _props.gap,
          onLoad = _props.onLoad;

      return (0, _rax.createElement)(
        _nukeView2.default,
        { className: 'imageview', style: _index2.default.imageview },
        (0, _rax.createElement)(
          _finger2.default,
          {
            onSingleTap: this.onSingleTap.bind(this),
            onPressMove: this.onPressMove.bind(this),
            onSwipe: this.onSwipe.bind(this)
          },
          (0, _rax.createElement)(
            _nukeView2.default,
            {
              ref: function ref(node) {
                _this2.list = (0, _rax.findDOMNode)(node);
              },
              className: 'imagelist',
              style: _index2.default.imagelist
            },
            imageList.map(function (item, i) {
              return (0, _rax.createElement)(
                _nukeView2.default,
                {
                  className: 'imagelist-item',
                  style: [_index2.default['imagelist-item'], { marginRight: gap + 'px' }],
                  key: 'img' + i
                },
                (0, _rax.createElement)(
                  _finger2.default,
                  {
                    onPressMove: _this2.onPicPressMove.bind(_this2),
                    onMultipointStart: _this2.onMultipointStart.bind(_this2),
                    onLongTap: _this2.onLongTap.bind(_this2),
                    onPinch: _this2.onPinch.bind(_this2),
                    onRotate: _this2.onRotate.bind(_this2),
                    onMultipointEnd: _this2.onMultipointEnd.bind(_this2),
                    onDoubleTap: _this2.onDoubleTap.bind(_this2)
                  },
                  (0, _rax.createElement)(_components.CenterImage, {
                    id: 'view' + i,
                    style: [_index2.default.img, {
                      position: 'absolute',
                      pointerEvents: 'none',
                      webkitUserSelect: 'none',
                      userSelect: 'none'
                    }],
                    src: item,
                    index: i,
                    current: _this2.state.current,
                    onLoad: function onLoad(e) {}
                  })
                )
              );
            })
          )
        ),
        disablePageNum ? null : (0, _rax.createElement)(
          _nukeView2.default,
          { className: 'page', ref: 'page' },
          this.state.current + 1,
          ' / ',
          this.arrLength
        ),
        desc ? (0, _rax.createElement)(_nukeView2.default, { dangerouslySetInnerHTML: { __html: desc } }) : null,
        children
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var current = this.state.current,
          _props2 = this.props,
          imageList = _props2.imageList,
          initCallback = _props2.initCallback;


      this.arrLength = imageList.length;

      (0, _transform2.default)(this.list);

      current && this.changeIndex(current, false);

      this.bindStyle(current);

      initCallback && initCallback();
      // window.addEventListener('orientationchange', this.onOrientationChange);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // window.removeEventListener('orientationchange', this.onOrientationChange);
    }
  }, {
    key: 'onSingleTap',
    value: function onSingleTap() {
      this.props.close && this.props.close();
    }
  }, {
    key: 'onPressMove',
    value: function onPressMove(evt) {
      var current = this.state.current;


      this.endAnimation();

      if (!this.focused) {
        if (current === 0 && evt.deltaX > 0 || current === this.arrLength - 1 && evt.deltaX < 0) {
          this.list.translateX += evt.deltaX / 3;
          // console.log('translateX', this.list.translateX);
        } else {
          this.list.translateX += evt.deltaX;
        }
      }

      evt.preventDefault();
    }
  }, {
    key: 'onSwipe',
    value: function onSwipe(evt) {
      var direction = evt.direction;
      var current = this.state.current;

      if (this.focused) {
        return false;
      }
      switch (direction) {
        case 'Left':
          current < this.arrLength - 1 && ++current && this.bindStyle(current);
          break;
        case 'Right':
          current > 0 && current-- && this.bindStyle(current);
          break;
      }
      this.changeIndex(current);
    }
  }, {
    key: 'onPicPressMove',
    value: function onPicPressMove(evt) {
      var deltaX = evt.deltaX,
          deltaY = evt.deltaY,
          isLongPic = this.ob.getAttribute('long'),
          _ob = this.ob,
          scaleX = _ob.scaleX,
          width = _ob.width;


      if (this.ob.scaleX <= 1 || evt.touches.length > 1) {
        return;
      }

      if (this.ob && this.checkBoundary(deltaX, deltaY)) {
        !isLongPic && (this.ob.translateX += deltaX);
        this.ob.translateY += deltaY;

        if (isLongPic && scaleX * width === this.screenWidth) {
          this.focused = false;
        } else {
          this.focused = true;
        }
      } else {
        this.focused = false;
      }
      // console.log('translate ',this.ob.translateX, this.ob.translateY);
    }
  }, {
    key: 'onMultipointStart',
    value: function onMultipointStart() {
      this.initScale = this.ob.scaleX;
    }
  }, {
    key: 'onPinch',
    value: function onPinch(evt) {
      if (this.props.disablePinch || this.ob.getAttribute('long')) {
        return false;
      }
      this.ob.style.webkitTransition = 'cubic-bezier(.25,.01,.25,1)';

      var _ob2 = this.ob,
          originX = _ob2.originX,
          originY = _ob2.originY,
          originX2 = evt.center.x - this.screenWidth / 2 - document.body.scrollLeft,
          originY2 = evt.center.y - this.screenHeight / 2 - document.body.scrollTop;


      this.ob.originX = originX2;
      this.ob.originY = originY2;
      this.ob.translateX = this.ob.translateX + (originX2 - originX) * this.ob.scaleX;
      this.ob.translateY = this.ob.translateY + (originY2 - originY) * this.ob.scaleY;

      this.ob.scaleX = this.ob.scaleY = this.initScale * evt.scale;
    }
  }, {
    key: 'onRotate',
    value: function onRotate(evt) {
      if (!this.props.enableRotate || this.ob.getAttribute('rate') >= 3.5) {
        return false;
      }

      this.ob.style.webkitTransition = 'cubic-bezier(.25,.01,.25,1)';

      this.ob.rotateZ += evt.angle;
    }
  }, {
    key: 'onLongTap',
    value: function onLongTap() {
      this.props.longTap && this.props.longTap();
    }
  }, {
    key: 'onMultipointEnd',
    value: function onMultipointEnd(evt) {
      // translate to normal
      this.changeIndex(this.state.current);

      if (!this.ob) {
        return;
      }

      this.ob.style.webkitTransition = '300ms ease';

      var maxScale = this.props.maxScale,
          isLongPic = this.ob.getAttribute('long');
      // scale to normal
      if (this.ob.scaleX < 1) {
        this.restore(false);
      }
      if (this.ob.scaleX > maxScale && !isLongPic) {
        this.setScale(maxScale);
      }

      // rotate to normal
      var rotation = this.ob.rotateZ % 360,
          rate = this.ob.getAttribute('rate');

      if (rotation < 0) {
        rotation = 360 + rotation;
      }
      this.ob.rotateZ = rotation;

      if (rotation > 0 && rotation < 45) {
        this.ob.rotateZ = 0;
      } else if (rotation >= 315) {
        this.ob.rotateZ = 360;
      } else if (rotation >= 45 && rotation < 135) {
        this.ob.rotateZ = 90;
        this.setScale(rate);
      } else if (rotation >= 135 && rotation < 225) {
        this.ob.rotateZ = 180;
      } else if (rotation >= 225 && rotation < 315) {
        this.ob.rotateZ = 270;
        this.setScale(rate);
      }
    }
  }, {
    key: 'onDoubleTap',
    value: function onDoubleTap(evt) {
      if (this.props.disableDoubleTap) {
        return false;
      }

      var origin = evt.origin,
          originX = origin[0] - this.screenWidth / 2 - document.body.scrollLeft,
          originY = origin[1] - this.screenHeight / 2 - document.body.scrollTop,
          isLongPic = this.ob.getAttribute('long');


      if (this.ob.scaleX === 1) {
        !isLongPic && (this.ob.translateX = this.ob.originX = originX);
        !isLongPic && (this.ob.translateY = this.ob.originY = originY);
        this.setScale(isLongPic ? this.screenWidth / this.ob.width : this.props.maxScale);
      } else {
        this.ob.translateX = this.ob.originX;
        this.ob.translateY = this.ob.originY;
        this.setScale(1);
      }

      // console.log('origin',this.ob.originX, this.ob.originY);
    }
  }, {
    key: 'setStyle',
    value: function setStyle(styleData) {
      var elementStyle = (0, _rax.findDOMNode)(this.refs.page).style;
      for (var styleName in styleData) {
        elementStyle[styleName] = styleData[styleName];
      }
    }
  }, {
    key: 'bindStyle',
    value: function bindStyle(current) {
      var _this3 = this;

      this.setState({ current: current }, function () {
        _this3.ob && _this3.restore();
        _this3.ob = (0, _rax.findDOMNode)('view' + current);
        if (_this3.ob && !_this3.ob.scaleX) {
          (0, _transform2.default)(_this3.ob);
        }
        // ease hide page number
        var page = _this3.refs.page;
        var style = {
          opacity: 0,
          transition: 'opacity 0.2s',
          webkitTransition: 'opacity 0.2s'
        };
        if (page) {
          _this3.setStyle({ opacity: 1 });
          setTimeout(function () {
            _this3.setStyle(style);
          }, 2000);
        }
      });
    }
  }, {
    key: 'changeIndex',
    value: function changeIndex(current) {
      var ease = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      ease && (this.list.style.webkitTransition = '300ms ease');
      this.list.translateX = -current * (this.screenWidth + this.props.gap);

      this.props.onChange && this.props.onChange(current);
    }
  }, {
    key: 'setScale',
    value: function setScale(size) {
      this.ob.style.webkitTransition = '300ms ease-in-out';
      this.ob.scaleX = this.ob.scaleY = size;
    }
  }, {
    key: 'restore',
    value: function restore() {
      var rotate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      this.ob.translateX = this.ob.translateY = 0;
      !!rotate && (this.ob.rotateZ = 0);
      this.ob.scaleX = this.ob.scaleY = 1;
      this.ob.originX = this.ob.originY = 0;
    }
  }, {
    key: 'endAnimation',
    value: function endAnimation() {
      this.list.style.webkitTransition = '0';
      this.ob && this.ob.style && (this.ob.style.webkitTransition = '0');
    }
  }, {
    key: 'checkBoundary',
    value: function checkBoundary() {
      var deltaX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var deltaY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      // console.log(this.ob.width, this.ob.height);
      var _ob3 = this.ob,
          scaleX = _ob3.scaleX,
          translateX = _ob3.translateX,
          translateY = _ob3.translateY,
          originX = _ob3.originX,
          originY = _ob3.originY,
          width = _ob3.width,
          height = _ob3.height,
          rate = this.ob.getAttribute('rate');


      if (scaleX !== 1 || scaleX !== rate) {
        // include long picture
        var rangeLeft = (scaleX - 1) * (width / 2 + originX) + originX,
            rangeRight = -(scaleX - 1) * (width / 2 - originX) + originX,
            rangeUp = (scaleX - 1) * (height / 2 + originY) + originY,
            rangeDown = -(scaleX - 1) * (height / 2 - originY) + originY;

        // console.log(rangeLeft, rangeRight, rangeUp, rangeDown);

        if (translateX + deltaX <= rangeLeft && translateX + deltaX >= rangeRight && translateY + deltaY <= rangeUp && translateY + deltaY >= rangeDown) {
          return true;
        }
      }
      return false;
    }
  }]);

  return ImageView;
}(_rax.Component);

ImageView.defaultProps = {
  gap: MARGIN,
  current: 0,
  disablePageNum: true,
  desc: '',
  maxScale: 2
};

ImageView.propTypes = {
  gap: _rax.PropTypes.number,
  maxScale: _rax.PropTypes.number,
  current: _rax.PropTypes.number,
  imageList: _rax.PropTypes.array.isRequired,
  disablePageNum: _rax.PropTypes.bool,
  disablePinch: _rax.PropTypes.bool,
  enableRotate: _rax.PropTypes.bool,
  disableDoubleTap: _rax.PropTypes.bool,
  longTap: _rax.PropTypes.func,
  close: _rax.PropTypes.func.isRequired,
  changeIndex: _rax.PropTypes.func,
  initCallback: _rax.PropTypes.func

};
exports.default = ImageView;
module.exports = exports['default'];