/** @jsx createElement */
import {
  createElement,
  render,
  unmountComponentAtNode,
  Component,
  PropTypes,
} from 'rax';
import Dom from 'nuke-dom';

export default class Singleton {
  constructor(component) {
    this.container = null;
    this.component = component;
    this.instance = null;
  }

  show(options) {
    if (!this.container) {
      this.container = Dom.createEle('div', { t: 'id', abc: '_nuke_wrap' });
      document.body.appendChild(this.container);
    }
    render(<this.component {...options} />, this.container, () => {
      this.instance = this;
      // this.instance.show();
    });
  }

  hide() {
    if (this.instance) {
      this.instance.hide();
    }
  }
}
