'use strict';

/** @jsx createElement */
import { createElement, Component } from 'rax';
import Dimensions from 'nuke-dimensions';

class Viewer extends Component {
  constructor(props) {
    super(props);
    this.state = {
      current: props.current
    };
    this.changeHandler = this.changeHandler.bind(this);
  }

  changeIndex(index) {
    this.setState({
      current: index
    });
  }
  imgOnLoad(index, e) {
    this.props.onLoad && this.props.onLoad(e, index);
  }
  changeHandler(e) {
    this.setState({
      current: e.index
    });
    this.props.onChange && this.props.onChange(e.index);
  }
  render() {
    const { style, imageList, onChange, loop, ...others } = this.props;
    // 兼容API标准
    let nativeProps = {
      ...others,
      onChange: this.changeHandler,
      offsetXAccuracy: '10',
      autoPlay: false,
      showIndicators: false,
      append: 'node',
      infinite: loop,
      index: this.state.current,
      style: Object.assign(styles.slider, style),
      ref: "myslider"


    };
    return <slider {...nativeProps}>
      {imageList.map((item, index) => {
        return (<imagezoom src={item} style={styles.imageview} resize={"contain"} onLoad={this.imgOnLoad.bind(this, index)}></imagezoom>);
      })}

    </slider>
      ;
  }
}
const styles = {
  slider: {
    width: 750,
    height: Dimensions.get('window').height,
  },
  imageview: {
    width: 750,
    // height: 1300,
    height: Dimensions.get('window').height,
    backgroundColor: '#000000',
    //animation: 'easeshow 0.25s',
  },
}
export default Viewer;
